# $Id: appleseeds-2.2.0-1.spec,v 1.5 2003/10/03 16:37:47 jhayes Exp $
#
# This is the RPM specification file for the AppleSeeds library.
#
Summary: A C library of portible system abstractions and container types.
Name: appleseeds
Version: 2.2.0
Release: 1
Copyright: UCSD
Group: Development/Libraries
Source: http://grail.sdsc.edu/projects/appleseeds/%{name}-%{version}.tar.gz
URL: http://grail.sdsc.edu/projects/appleseeds
Vendor: Grid Research and Innovation Laboratory (GRAIL)
BuildRoot: %{_builddir}/%{name}-root
Prefix: /usr

%description
AppleSeeds comprises a library of functions intended to ease the development of
distributed software.  These functions support development projects by:
encapsulating system-dependent code so that code can be ported between
architectures without modification; hiding some of the grimier details of
system calls behind a convenient set of abstractions; providing general-use
utilities that make code easier to develop and use.

%prep
%setup -q

%build
./configure
make

%install
if test -n "$RPM_BUILD_ROOT" -a ! -e "$RPM_BUILD_ROOT"; then
  mkdir $RPM_BUILD_ROOT
fi
make INSTALL_DIR="$RPM_BUILD_ROOT/usr" install_headers install_lib

%files
%defattr(-,root,root)
/usr/lib/libappleseeds.a
/usr/include/appleseeds/appleseeds.h
/usr/include/appleseeds/diagnosticseed.h
/usr/include/appleseeds/envseed.h
/usr/include/appleseeds/execseed.h
/usr/include/appleseeds/fileseed.h
/usr/include/appleseeds/formatseed.h
/usr/include/appleseeds/hashseed.h
/usr/include/appleseeds/ipseed.h
/usr/include/appleseeds/oshseed.h
/usr/include/appleseeds/propertyseed.h
/usr/include/appleseeds/semseed.h
/usr/include/appleseeds/shmseed.h
/usr/include/appleseeds/strseed.h
/usr/include/appleseeds/vectorseed.h
/usr/include/appleseeds/xmlseed.h

%changelog
* Tue Sep 23 2003 Jim Hayes <jhayes@cs.ucsd.edu>
- add execseed.h
* Tue Nov 26 2002 Jim Hayes <jhayes@cs.ucsd.edu>
- add xmlseed.h
* Fri May 11 2002 Jim Hayes <jhayes@cs.ucsd.edu>
- add packaging commands
