/*
 * Copyright (c) 2000-2003 Illinois Institute of Technology.
 *                         All rights reserved.
 *
 * This file is part of the GHS software package.  For license
 * information, see the LICENSE file in the top level directory of the
 * GHS source distribution.
 *
 * Released Date: August 18 2005
 * This is the GHS I release by the
 *   SCS Group,
 *   http://www.cs.iit.edu/~scs
 *   Department of Computer Science,
 *   Illinois Institute of Technology.
 *
 * This release has been tested under SUN OS 5.9.
 *
 * Supervisor
 * ----------
 * Illiniois Institute of Technology:
 * -Dr. Xian-He Sun
 *
 * Author(s)
 * -----------------
 * Illinois Institute of Technology:
 * -Ming Wu
 * -Xian-He Sun
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <unistd.h>
#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include "ghs.h"

//#define PORT 3490 // the port client will be connecting to 

#define MAX_DATA_SIZE 100 // max number of bytes we can get at once
#define MAX_PARA_SIZE 120
//#define BUF_SIZE 30

int 
main(int argc, char *argv[])
{
  int sockServerfd, numBytes;
  int i = 0;
  char buf[MAX_DATA_SIZE];
  char paraBuf[MAX_PARA_SIZE];
  char hostName[80];
  int hn, hostNamelength = 80;
  struct hostent *he;
  struct sockaddr_in myAddr;    // my address information
  struct sockaddr_in serverAddr; // GHS server's address information
  int predScope = 1;
  int messageType;

  if (argc != 4) 
  {
    fprintf(stderr,"usage: servertest servername clientname period\n");
    exit(1);
  }

  if ((he = gethostbyname(argv[1])) == NULL) // get the host info
  {   
    perror("gethostbyname");
    exit(1);
  }
	
  if ((hn = gethostname(hostName, hostNamelength)) == -1)
  {
    perror("gethostName");
    exit(1);
  }

  printf("the host name is %s \n", hostName);
  

  // sprintf(buf, "%s %s\n", hostName, paraBuf);

  if ((sockServerfd = socket(AF_INET, SOCK_STREAM, 0)) == -1) 
  {
    perror("socket");
    exit(1);
  }

  serverAddr.sin_family = AF_INET;    // host byte order 
  serverAddr.sin_port = htons(SERVER_PORT);  // short, network byte order 
  serverAddr.sin_addr = *((struct in_addr *)he->h_addr);
  memset(&(serverAddr.sin_zero), '\0', 8);  // zero the rest of the struct 

  if (connect(sockServerfd, (struct sockaddr *)&serverAddr, sizeof(struct sockaddr)) == -1) 
  {
    perror("connect");
    exit(1);
  }

  sscanf(argv[3], "%d", &predScope);
  sprintf(buf, "%d %s %d \n", SERVER_INQUIRY, argv[2], predScope);
  printf("the buf is %s", buf);
  if (send(sockServerfd, buf, MAX_DATA_SIZE, 0) == -1) perror("send");

  if ((numBytes = recv(sockServerfd, buf, MAX_DATA_SIZE - 1, 0)) == -1) 
  {
    perror("recv");
    exit(1);
  }
  printf("the buf received is %s", buf);

  close(sockServerfd);
	
  return 0;
}

